# Minecraft 服务器UUID迁移助手

**专为整合包服务器设计的玩家数据迁移工具**  
轻松解决玩家UUID变更导致的数据丢失问题，完美支持主流FTB模组数据迁移。

---

### 🎯 核心功能
- **玩家档案迁移**  
  更新`usercache.json`和`usernamecache.json`中的UUID映射，保持玩家身份一致性

- **FTB模组支持**  
  自动处理以下模组数据文件：  
  - **FTB Teams**  
    - 战队成员数据 (`/world/ftbteams/party`)  
    - 玩家个人档案 (`/world/ftbteams/player`)  
  - **FTB Chunks**  
    - 领地权限数据 (`/world/ftbchunks`)  
  - **FTB Quests**  
    - 任务进度存档 (`/world/ftbquests`)  

- **智能文件处理**  
  自动识别并更新涉及UUID的：  
  - 配置文件内容  
  - 文件名与目录名  
  - 嵌套数据结构  

---

### 🚀 使用场景
- 玩家账户系统升级时保持数据连贯  
- 切换正版/离线模式时的数据迁移  
- 玩家身份信息异常后的数据修复  
- 服务器合并时的玩家数据整合  

---

### 📦 使用方式
1. **单次迁移模式**  
   跟随引导输入服务器路径、新旧UUID即可

### 2. 批量处理模式

**适用场景**  
同时处理多个玩家的UUID变更需求，适合大规模数据迁移

**操作流程**  
1. **创建配置文件**  
   新建`migration.json`文件，内容示例：
   ```json
   {
     "path": "C:/你的服务器路径",
     "mappings": {
       "原UUID1": "新UUID1",
       "原UUID2": "新UUID2"
     }
   }
   ```
  (这部分数据可以通过项目[mcserver_player_uuid_modifier](https://github.com/shaokeyibb/mcserver_player_uuid_modifier)获得，并可直接通过ai进行转换格式)
  
2. **填写配置信息**  
   - `path`: 填写你的服务器根目录绝对路径
   - `mappings`: 按`"旧UUID": "新UUID"`格式添加需要变更的对应关系

3. **执行迁移命令**  
   ```bash
   python uuid.py --config migration.json
   ```
   
   ```cmd
   uuid.exe --config migration.json
   ```

**配置示例**  
处理两位玩家的数据迁移：
```json
{
  "path": "C:/mc_server",
  "mappings": {
    "850c1551-a4af-4d56-88b5-2a041232be56": "1f06a2e9-fdc1-3392-80a2-b72ea9cd12f8",
    "79f25117-0128-4329-86f7-618a8d983c82": "dda6094c-bc6b-3d53-b379-af7535d95c5d"
  }
}
```

**效果说明**  
程序将自动完成：
- 所有配置文件的UUID更新
- 涉及模组数据的内容替换
- 相关文件/目录的重命名操作

⚠️ **注意事项**  
- 请使用纯文本编辑器创建配置文件
- 路径请使用正斜杠`/`（兼容Windows/Linux）
- 确保所有UUID格式正确

---

### ⚠️ 注意事项
- 操作前请务必备份服务器数据  
- 建议在服务器离线状态下执行  
- 确保对数据文件有读写权限  

---

> 无需复杂操作，三步完成玩家数据无缝迁移，保障服务器平稳过渡！  